//------------------------------------------------------------------------
// File for project XCALC
//------------------------------------------------------------------------
// "Dot" Window procedure
// Actions:
//	- glow blue (or radix, if not 10) if window active
//  - show system menu on right click
//------------------------------------------------------------------------

#include "xcalc.h"

char *aDotDesc = "Click to show menu";

LRESULT CALLBACK DotProc(HWND hwnd, UINT wMsg, WPARAM wParam, LPARAM lParam)
{
	RECT rect;

	// Relay to XCALC ToolTip window
	GetClientRect(hwnd,&rect);
	ToolTipEvent(hwnd,wMsg,wParam,lParam,&rect,aDotDesc);

	switch (wMsg) {
	case WM_PAINT:
	{
		PAINTSTRUCT ps;
		RECT rect;
		HGDIOBJ holdbitmap;
		int selix;
		
		BeginPaint(hwnd,&ps);
		GetClientRect(hwnd,&rect);
		FillRect(ps.hdc,&rect,hBackBrush);
		if (GetActiveWindow() == hwndXCALC || GetActiveWindow() == hwnd) {
			holdbitmap = SelectObject(hDigitsDC,hbStatus);
			SetTextColor(ps.hdc,GetColour(RGBBACK));
			SetBkColor(ps.hdc,GetColour(RGBCAPTION));
			selix = RADIX_LIN + (wRadix!=10?sWordSize*3:0);
			BitBlt(
				ps.hdc,
				0,0,StatusX,StatusY,
				hDigitsDC,
				selix*StatusX,0,SRCCOPY);
			SelectObject(hDigitsDC,holdbitmap);
		}
		EndPaint(hwnd,&ps);
		break;
	}
	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
		SetActiveWindow(hwndXCALC);
		//InvalidateRect(hwnd,NULL,FALSE);
		break;
	case WM_RBUTTONUP:
	case WM_LBUTTONUP:
		if (!Title) {
			HMENU hSystemMenu = GetSystemMenu(hwndXCALC,FALSE);
			int syscmd;
			POINT pt;
			GetCursorPos(&pt);
			SetForegroundWindow(hwndXCALC);
			syscmd = TrackPopupMenuEx(hSystemMenu,TPM_RETURNCMD,pt.x,pt.y,hwndXCALC,NULL);
			if (syscmd) {
				PostMessage(hwndXCALC,WM_SYSCOMMAND,syscmd,0);
			}
		}
		break;
	default:
		return DefWindowProc(hwnd,wMsg,wParam,lParam);
	}
	return 0;
}
