//------------------------------------------------------------------------
// getcolou.c for xcalc v1.3+
//------------------------------------------------------------------------
// Functions:
//
// void InitColour() - reads colours from .ini file
// COLORREF GetColour(int) - gets RGB colour from index
//
// 29/9/94 Bernt R
//------------------------------------------------------------------------

#include "xcalc.h"

const char * const ColNames[NCOLOURS] = {
	"BACKGROUND",
	"BORDER",
	"3DBRIGHT",
	"3DDARK",
	"BUTTONTEXT",
	"GRAYBUTTONTEXT",
	"SELECTEDBUTTON",
	"MESSAGE",
	"CAPTION",
	"KEYCAPS",
	"DIGITS"
};

const char * const DfltCols[NCOLOURS] = {
	"  0   0 128",
	"  0   0 128",
	"  0   0 255",
	"  0   0   0",
	"255 255 255",
	"128 128 128",
	"255   0   0",
	"  0 255   0",
	"  0 255 255",
	"255 255   0",
	"  0 255 255"
};
/*
const char * const DfltCols[NCOLOURS] = {
	"128 128 128",
	"128 128 128",
	"192 192 192",
	" 20  20  20",
	"255 255 255",
	"  0   0   0",
	"255   0   0",
	"  0 255   0",
	"  0   0 255",
	"255 255   0",
	"  0 255 255"
};
*/
COLORREF Colrs[NCOLOURS];

void InitColour(void)
{
	char buff[32];
	WORD r,g,b;
	int i;
	
	for (i=0;i<NCOLOURS;i++) {
		GetPrivateProfileString("Colours",ColNames[i],DfltCols[i],buff,32,IniFile);
		sscanf(buff,"%hu %hu %hu",&r,&g,&b);
		Colrs[i] = RGB(r,g,b);
	}
}

void WriteColour(void)
{
	char buff[32];
	int i;
	
	for (i=0;i<NCOLOURS;i++) {
		sprintf(buff,"%hu %hu %hu",
			(WORD)GetRValue(Colrs[i]),
			(WORD)GetGValue(Colrs[i]),
			(WORD)GetBValue(Colrs[i]));
		WritePrivateProfileString("Colours",ColNames[i],buff,IniFile);
	}
}

COLORREF GetColour(int index)
{
	return Colrs[index];
}

void SetColour(int index,COLORREF col)
{
	Colrs[index] = col;
}
