//------------------------------------------------------------------------
// File for project XCALC
//------------------------------------------------------------------------
// MakeBorder - routine shared by all windows
// Actions:
//	- draw border at edge of given rectangle
//------------------------------------------------------------------------

#include "xcalc.h"

void MakeBorder(HDC hdc,RECT *rect)
{
	int lft,top,rgt,bot;
	RECT rect2;
	
	lft = rect->left;
	top = rect->top;
	rgt = rect->right;
	bot = rect->bottom;
	
	//outer border
	//top
	SetRect(&rect2,lft,top,rgt,top+Border-1);
	FillRect(hdc,&rect2,hBorderBrush);
	
	//bottom
	SetRect(&rect2,lft,bot-Border+1,rgt,bot);
	FillRect(hdc,&rect2,hBorderBrush);
	
	//left
	SetRect(&rect2,lft,top,Border-1,bot);
	FillRect(hdc,&rect2,hBorderBrush);
	
	//right
	SetRect(&rect2,rgt-Border+1,top,rgt,bot);
	FillRect(hdc,&rect2,hBorderBrush);
	
	//3d look
	SelectObject(hdc,hDarkPen);
	MoveTo(hdc,Border-1,bot-Border);
	LineTo(hdc,Border-1,top+Border-1);
	LineTo(hdc,rgt-Border,top+Border-1);
	
	SelectObject(hdc,hBrightPen);
	LineTo(hdc,rgt-Border,bot-Border);
	LineTo(hdc,Border-2,bot-Border);
	
	//update rect to point inside the border
	
	rect->left += Border;       // rect now contains writing area
	rect->top += Border;        // (inside the border)
	rect->right -= Border;
	rect->bottom -= Border;
}

