//------------------------------------------------------------------------
// File for project XCALC
//------------------------------------------------------------------------
// Program procedures
// Actions:
//	- run programs
//------------------------------------------------------------------------

#include "xcalc.h"

// Runs a program. Note: one-based. Pr1 thus runs p=1 etc.

void RunProgram(int p)
{
	char progfile[_MAX_PATH];
	FILE *f;
	sprintf(progfile,"prog%d.txt",p);
	if ((f = fopen(progfile,"r"))!=NULL) {
		int *prog;
		char line[512];
		char sep[] = " \t\r\n";
		int n = 0;
		int i;
		key *k;
		while (!feof(f)) {
			if (fgets(line,512,f) && line[0]!='#') {
				char *p = strtok(line,sep);
				while (p) {
					BOOL num = TRUE;
					int l = lstrlen(p);
					for (i=0;i<l && num;i++) {
						int c = tolower(p[i]);
						num &= c=='.' || c==',' || c>='0'&&c<='9' || c>='a'&&c<='f';
					}
					if (num) n += l;
					else n++;
					p = strtok(NULL,sep);
				}
			}
		}
		prog = calloc(n,sizeof(int));
		n = 0;
		fseek(f,0,SEEK_SET);
		while (!feof(f)) {
			if (fgets(line,512,f) && line[0]!='#') {
				char *p = strtok(line,sep);
				while (p) {
					BOOL num = TRUE;
					int l = lstrlen(p);
					// decode numbers -- 1.23e4 or .2,3.4
					for (i=0;i<l && num;i++) {
						int c = tolower(p[i]);
						num &= c=='.' || c==',' || c>='0'&&c<='9' || c>='a'&&c<='f';
					}
					if (num) {
						for (i=0;i<l;i++) {
							int c = tolower(p[i]);
							if      (c==(k_useComma?',':'.')) prog[n++] = k_useComma?KEY_POINTC:KEY_POINTP;
							else if (c==(k_useComma?'.':',')) prog[n++] = k_useComma?KEY_IMAGP:KEY_IMAGC;
							else if (c>='0'&&c<='9') prog[n++] = KEY_0+c-'0';
							else if (c>='a'&&c<='f') prog[n++] = KEY_A+c-'a';
						}
					} else {
						for (i=0;i<NKEYID;i++) {
							if (!stricmp(p,Key[i].name) && (CURR_RADIX&Key[i].mode)) {
								prog[n++] = Key[i].id;
								break;
							}
						}
					}
					p = strtok(NULL,sep);
				}
			}
		}
		for (i=0;i<n;i++) {
			k = Key+prog[i];
			// fudge here for Undo key (and other keys to send AS_xxxx):
			if (k->op[0] == _AS)
				PostMessage(hwndXCALC,WM_COMMAND,k->op[1],0);
			else if (k->op[0]) {
				PostMessage(hwndXCALC,WM_KEYDOWN,k->op[0],0);
				if (k->op[1]) {
					PostMessage(hwndXCALC,WM_KEYDOWN,k->op[1],0);
					PostMessage(hwndXCALC,WM_KEYUP,k->op[1],0);
				}
				PostMessage(hwndXCALC,WM_KEYUP,k->op[0],0);
			}
			else if (k->op[1]) {
				PostMessage(hwndXCALC,WM_CHAR,k->op[1],0);
			}
		}
		fclose(f);
		free(prog);
	}
}
