//------------------------------------------------------------------------
// File for projects XCALC_A and XCALC_B
//------------------------------------------------------------------------
// This file contains all global variables declared as extern in XCALC.H
// and used freely in the various routines.
//------------------------------------------------------------------------

#include "xcalc.h"

//--All-purpose Global Variables------------------------------------------
const char	IniFile0[] =				"XCALC.ini";
const char	DatFile0[] =				"XCALC.dat";
const char	HelpExt[_MAX_EXT]  =		".chm";
char		XCALCDir[_MAX_PATH] =		"";
char		DatFile[_MAX_PATH] =		"";
char		IniFile[_MAX_PATH] =		"";
char		HelpFile[_MAX_PATH] =		""; // Always same as exe path, but with .chm
const char	ClassName[] =				"XCALC";
const char	DefaultBitmap[]=			"DIGITS1";
const char	DefaultFont[]=				"Courier New";
const char	VersionBitmap[] =			"XCALCVERSION";
const char	StatusBitmap[] =			"STATUS";
const char	Printable[NPRINTABLE+1] =	" 1234567890ABCDEF.-+ei,/'\"";

int			nKeyRows = 6;
int			nKeyCols = 10;

// Jul 97: Printable no longer a constant. A fudge is supplied in
// dialogs.c to possibly switch the "," and "." positions.
// Aug 97: back to constant again -- do a different strategy for
// displaying "," or ".". If we change Printable, creation of new
// bitmaps (from fonts) will have comma/period in the wrong places.

int			BitmapX; 				// width of digit bitmaps
int			BitmapY; 				// height of same
int			Border;					// border width
int			LogoX, LogoY;			// size of "Version" Logo

HWND		hwndXCALC,hwndEditKeys,hwndEditProgram,hDisplay[MAXSTKSIZ],hDot,hFix,hDispMode[NMODES],
			hButton[NBUTTONS],hError,hMemory,
			*hwndKey = NULL,
			hMemoryPopup,hMemoryDisplay[MEMSIZ],hwndToolTip;
HDC			hDigitsDC;
HPEN		hBrightPen,hDarkPen,hSelectedPen,hCaptionPen;
HBRUSH		hBorderBrush,hBackBrush,hSelectedBrush,hCaptionBrush;
HFONT		hBigFont,hBigFont_,hSmallFont,hSmallFont_,hSymbolFont,hToolTipFont;
HINSTANCE	hInst;

// These bitmap handles are used with hDigitsDC only. Must be preserved.
HBITMAP		hbOld,hbDigits,hbVersion,hbStatus;

int			ScreenX0,ScreenX1,ScreenY0,ScreenY1;
int			StkSiz;
int			MinStkSiz;
int			StatusX,StatusY;
int 		DisplayX,DisplayY,BrdWidth,BrdHeight;
int			ButWidth,ButHeight,FixWidth,DCHYPos,FSEYPos,FixYPos,DecoYPos;
int			KeyWidth,KeyXOffset,KeyXOffset2;
int			TotalWidth,TotalHeight,ClientWidth,ClientHeight;
int			WindowX,WindowY;
int			KeyYPos;
int     	BigFontY,SmallFontY,ToolTipFontY;
int			SizeX,SizeY;
int			DisplayStkSiz;

BOOL		SoundOn,ToolTip,ZeroOverflow,CopyTop,InvTrigAsDMS,MessagePopup,AllowEdit,SaveRegs,IsBin,ThousandSep,ThousandthSep;
BOOL		Restart = FALSE, NewKB = FALSE, RefreshNow = FALSE;

// We keep separate copies of these variables for Norm/Mini, and one in use:
BOOL		Mini;

BOOL		m_InTray;
int			m_Size,m_WindowX,m_WindowY,m_PopupX,m_PopupY,m_EnableMouseMove;
int			m_PopupSize,m_DisplayStkSiz;
BOOL		m_UseFonts,m_Bold,m_KeepInFront;
char		m_FontName[64];
char		m_BitmapName[32];
BOOL		m_IconStart;
BOOL		m_ShowMemoryPopup;
int			m_MemCols;
BOOL		m_ShowTitle,m_ShowPane1,m_ShowPane2,m_ShowPane3,m_ShowPane4,m_ShowPane5;

BOOL		n_InTray;
int			n_Size,n_WindowX,n_WindowY,n_PopupX,n_PopupY,n_EnableMouseMove;
int			n_PopupSize,n_DisplayStkSiz;
BOOL		n_UseFonts,n_Bold,n_KeepInFront;
char		n_FontName[64];
char		n_BitmapName[32];
BOOL		n_IconStart;
BOOL		n_ShowMemoryPopup;
int			n_MemCols;
BOOL		n_ShowTitle,n_ShowPane1,n_ShowPane2,n_ShowPane3,n_ShowPane4,n_ShowPane5;

BOOL		InTray;
int			Size,EnableMouseMove;
int			PopupX,PopupY;
int			PopupDX,PopupDY;
int			PopupSize,DisplayStkSiz;
BOOL		UseFonts,Bold,KeepInFront;
char		FontName[64];
char		BitmapName[32];
BOOL		ShowMemoryPopup;
int			MemRows,MemCols;
BOOL 		Title,Pane1,Pane2,Pane3,Pane4,Pane5;

//--Math Global Variables-------------------------------------------------

int			Error;						// Is set by matherr() and other routines
int			iState;           			// 0 for normal, !=0 for inkey operations
int			iMaxDigits;         		// For current mode of operation
UNDOTYPE	Undone;						// Last undone operation
WORD		wDispMode;        			// DCHOB | FSE | DR
short		sWordSize;					// 0:32bit, 1:16bit, 2:8bit
WORD		wRadix;						// 10 for decimal etc..
WORD		wDecDR;						// Saves D/R mode for Decimal setting
char		cST[MAXSTKSIZ][NDIGITS+1];	// Display output buffer
char		STR[NDIGITS+2];				// Input key buffer
short		sFix;						// -1 for float
//short		sWordLength;				// 2..32, for binary operations
BOOL		bCleanFrac;					// TRUE for 'd/c' not 'a b/c'
BOOL 		bSL;              			// Stacklift true/false
BOOL		bShift;						// TRUE for shift key down
BOOL		Dirty;						// TRUE if all stack needs update
BOOL		k_useComma;					// TRUE for keyboard decimal comma ","
BOOL		d_useComma;					// TRUE for display decimal comma ","
BOOL		c_useComma;					// TRUE for clipboard decimal comma ","
BOOL		Cstyle;						// TRUE to use 0x.. clipboard copy
Register	ST[MAXNUMREGS];   			// Topmost element is LastX
Register	SaveReg;            		// Temp register for LastX
Register	Memory[MEMSIZ];				// Memory registers
LD			ldConstant;					// Temporary used to paste constants
BOOL		bHyperbolic = FALSE;		// Hyperboli key fudge

//--Accutate PI across versions-------------------------------------------

#ifdef __BORLANDC__
const char m_pi[] = {0x35,0xc2,0x68,0x21,0xa2,0xda,0x0f,0xc9,0x00,0x40};
const LD * const M_PI_L_PTR = (LD*)m_pi;
#endif

//--Undo information------------------------------------------------------

UndoInfoStruct UndoInfo[MAXUNDO];
int UndoIndex;
//int RedoMaxIndex;

//--Limit digits on input-------------------------------------------------

const int aMaxInputDigits[][NMODECOLS] = {  // indexed by [sWordSize][RADIX_LIN]
	{
		DECMAXDIGITS,
		CPLXMAXDIGITS,
		HEXMAXDIGITS,
		OCTMAXDIGITS,
		BINMAXDIGITS,
	},
	{
		DECMAXDIGITS,
		CPLXMAXDIGITS,
		HEXMAXDIGITS16,
		OCTMAXDIGITS16,
		BINMAXDIGITS16,
	},
	{
		DECMAXDIGITS,
		CPLXMAXDIGITS,
		HEXMAXDIGITS8,
		OCTMAXDIGITS8,
		BINMAXDIGITS8,
	},
};

//--Different binary word sizes-------------------------------------------

const int aBits[] = {
	32,
	16,
	8,
};

const int aWordMask[] = {
	0xffffffff,
	0x0000ffff,
	0x000000ff,
};

const LD aBinMax[] = {
	LONG_MAX,
	SHRT_MAX,
	SCHAR_MAX,
};

const LD aBinMin[] = {
	LONG_MIN,
	SHRT_MIN,
	SCHAR_MIN,
};

//--Mode names-----------------------------------------------------------

const char *ModeNames[NMODECOLS] = {      // indexed by RADIX_LIN
	"decimal",
	"complex",
	"hex",
	"octal",
	"binary"
};

//--Radix from mode-------------------------------------------------------

const WORD aRadix[NMODECOLS] = {      // indexed by RADIX_LIN
	10,
	10,
	16,
	8,
	2
};

//--Error message text----------------------------------------------------

const char * const ErrMsg[] =
{
	"",
	"Division by zero",
	"Out of range",
	"Math domain error",
	"Math singularity",
	"No significant digits",
	"General error",
	"No more undo information"
};

//--Undo/Redo message text------------------------------------------------

const char * const UndoMsg[] =
{
	"(none)","inkey","enter",
	"add","subtract","multiply","divide",
	"store","recall","clear memory","paste",
	"sin","cos","tan","arcsin","arccos","arctan",
	"sinh","cosh","tanh","arsinh","arcosh","artanh",
	"fix","scientific","engineering","fix/float","degree","radian",
	"word size",
	"decimal","complex","hex","octal","binary",
	"clear","last X","x<>y","re<>im","change sign","percent","modulo","integer division",
	"y+ix","pi","conjugate","absolute value","power","root","factorial",
	"square root","square","exponential","ln","10^x","log","reciprocal",
	"clear stack","roll up","roll down",
	"or","and","xor","not",
	"rotate left","shift left","arithmetic shift left",
	"rotate right","shift right","arithmetic shift right",
	"cube root","random","(r,i)->(y,x)","cartesian","polar","fraction","integer",
	"convert","degree minute second", "round","constant","cube",
	"clear all memory",
};

//--General message text--------------------------------------------------

char *Message;

//--Conversion globals----------------------------------------------------

// Remember selections for each conversion type
short ConvType	= IDD_TEMPERATURE;
short From		= IDD_FROM0;	// initial "from"
short To		= IDD_TO0;		// initial "to"

short SelectFrom[NCONVERSIONS] =
	{IDD_FROM0,IDD_FROM0,IDD_FROM0,IDD_FROM0,IDD_FROM0,IDD_FROM0,IDD_FROM0,IDD_FROM0,IDD_FROM0,IDD_FROM0};
short SelectTo[NCONVERSIONS] =
	{IDD_TO0,IDD_TO0,IDD_TO0,IDD_TO0,IDD_TO0,IDD_TO0,IDD_TO0,IDD_TO0,IDD_TO0,IDD_TO0};

